import { Injectable } from '@angular/core';
import { Store, select } from '@ngrx/store';

import { RPCSubscriber } from '@loafer/ng-rpc/decorator';

import * as DiscoveryStore from '../store/notification';

import {
  Zone,
  Host,
  Port,
  Service,
} from '../model';

@Injectable()
export class DiscoverySubscriber {

  public constructor(
    private store: Store<DiscoveryStore.State>,
  ) {
  }

  @RPCSubscriber({method: 'DiscoveryService.discoveredZone'})
  public discoveredZone(zone: Zone): void {
    this.store.dispatch(new DiscoveryStore.DiscoveredZone(zone));
  }
  @RPCSubscriber({method: 'DiscoveryService.discoveredHost'})
  public discoveredHost(host: Host): void {
    this.store.dispatch(new DiscoveryStore.DiscoveredHost(host));
  }
  @RPCSubscriber({method: 'DiscoveryService.discoveredPort'})
  public discoveredPort(port: Port): void {
    this.store.dispatch(new DiscoveryStore.DiscoveredPort(port));
  }
  @RPCSubscriber({method: 'DiscoveryService.discoveredService'})
  public discoveredService(service: Service): void {
    this.store.dispatch(new DiscoveryStore.DiscoveredService(service));
  }
}
